<?php
/**
 * CodeIgniter
 *
 * An open source application development framework for PHP
 *
 * This content is released under the MIT License (MIT)
 *
 * Copyright (c) 2014 - 2019, British Columbia Institute of Technology
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 *
 * @package	CodeIgniter
 * @author	EllisLab Dev Team
 * @copyright	Copyright (c) 2008 - 2014, EllisLab, Inc. (https://ellislab.com/)
 * @copyright	Copyright (c) 2014 - 2019, British Columbia Institute of Technology (https://bcit.ca/)
 * @license	https://opensource.org/licenses/MIT	MIT License
 * @link	https://codeigniter.com
 * @since	Version 1.0.0
 * @filesource
 */
defined('BASEPATH') OR exit('Non è permesso l\'accesso diretto allo script');

$lang['form_validation_required']		= 'Il campo {field} è obbligatorio.';
$lang['form_validation_isset']			= 'Il campo {field} deve avere un valore.';
$lang['form_validation_valid_email']		= 'Il campo {field} deve contenere un indirizzo email valido.';
$lang['form_validation_valid_emails']		= 'Il campo {field} deve contenere degli indirizzi email validi.';
$lang['form_validation_valid_url']		= 'Il campo {field} deve contenere un URL valido.';
$lang['form_validation_valid_ip']		= 'Il campo {field} deve contenere un IP valido.';
$lang['form_validation_valid_mac']		= 'Il campo {field} deve contenere un MAC valido.';
$lang['form_validation_valid_base64']		= 'Il campo {field} deve contenere una stringa Base64 valida.';
$lang['form_validation_min_length']		= 'Il campo {field} deve avere una lunghezza di almeno {param} caratteri.';
$lang['form_validation_max_length']		= 'Il campo {field} non può superare {param} caratteri di lunghezza.';
$lang['form_validation_exact_length']		= 'Il campo {field} deve avere esattamente {param} caratteri di lunghezza.';
$lang['form_validation_alpha']			= 'Il campo {field} può contenere solo caratteri alfabetici.';
$lang['form_validation_alpha_numeric']		= 'Il campo {field} può contenere solo caratteri alfanumerici.';
$lang['form_validation_alpha_numeric_spaces']	= 'Il campo {field} può contenere solo caratteri alfanumerici e spazi.';
$lang['form_validation_alpha_dash']		= 'Il campo {field} può contenere solo caratteri alfanumerici, trattini bassi e trattini.';
$lang['form_validation_numeric']		= 'Il campo {field} deve contenere solo numeri.';
$lang['form_validation_is_numeric']		= 'Il campo {field} deve contenere solo caratteri numerici.';
$lang['form_validation_integer']		= 'Il campo {field} deve contenere un numero intero.';
$lang['form_validation_regex_match']		= 'Il campo {field} non è nel formato corretto.';
$lang['form_validation_matches']		= 'Il campo {field} non corrisponde al campo {param}.';
$lang['form_validation_differs']		= 'Il campo {field} deve differire dal campo {param}.';
$lang['form_validation_is_unique'] 		= 'Il campo {field} deve contenere un valore univoco.';
$lang['form_validation_is_natural']		= 'Il campo {field} deve contenere solo cifre.';
$lang['form_validation_is_natural_no_zero']	= 'Il campo {field} deve contenere solo cifre e deve essere maggiore di zero.';
$lang['form_validation_decimal']		= 'Il campo {field} deve contenere un numero decimale.';
$lang['form_validation_less_than']		= 'Il campo {field} deve contenere un numero inferiore a {param}.';
$lang['form_validation_less_than_equal_to']	= 'Il campo {field} deve contenere un numero minore o uguale a {param}.';
$lang['form_validation_greater_than']		= 'Il campo {field} deve contenere un numero maggiore di {param}.';
$lang['form_validation_greater_than_equal_to']	= 'Il campo {field} deve contenere un numero maggiore o uguale a {param}.';
$lang['form_validation_error_message_not_set']	= 'Impossibile accedere a un messaggio di errore corrispondente al nome del campo {field}.';
$lang['form_validation_in_list']		= 'Il campo {field} il campo deve essere uno di: {param}.';
